<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
* IPS Payment Module Class
* Used in conjunction with the IPS payment module
* for transactions with ips.com, a Credit card processor using their Hosted page solution. 
*
* @version $Id: ps_ipspay.php,v 1.0 2010/03/05 alinoz Exp $
* @package VirtueMart
* @subpackage payment
* Written By Alin Ozi
*
* IPS (http://www.ips.com.cn/)
* VirtueMart (http://virtuemart.net)
*/

class ps_ipspay {

    var $classname = "ps_ipspay";
    var $payment_code = "IPSPAY";
    
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() {
        global $VM_LANG;
        $db = new ps_DB();
        
        /** Read current Configuration ***/
        require_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php");

        ?>
        <table>
          <tr>
	          <td><strong>IPS Development URL</strong></td>
              <td><input type="text" name="IPSPAY_DEV_URL" class="inputbox" value="<?php  echo IPSPAY_DEV_URL ?>" /></td>
              <td>The IPSPAY Development URL. This will be used for testing only. When setting IPSPAY_DEV to No this will be ignored.</td>
          </tr>
          <tr>
	          <td><strong>IPS Live Site URL</strong></td>
              <td><input type="text" name="IPSPAY_LIVE_URL" class="inputbox" value="<?php  echo IPSPAY_LIVE_URL ?>" /></td>
              <td>The IPSPAY Production URL. This is the url where the payements requrest are send. No need to change unless IPS notifies you.</td>
          </tr>
          <tr>
	          <td><strong>IPSPAY Merchant Code</strong></td>
              <td><input type="text" name="IPSPAY_MERCHANT_CODE" class="inputbox" value="<?php  echo IPSPAY_MERCHANT_CODE ?>" /></td>
              <td>The IPS merchant code that IPS have given you.</td>
          </tr> 
          
          <tr>
	          <td><strong>IPSPAY Order Encode Type</strong></td>
              <td>
			  		<select name="IPSPAY_ORDER_ENCODE_TYPE">
			  		<?php 
					$currencys = array( '0'=>'No Encryption',
					    '2' => 'MD5');
					
					foreach($currencys as $k => $v)
					{
						if(IPSPAY_ORDER_ENCODE_TYPE == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>
					</select>
              <td>The Server to Server method include a call back to the notify script. So in case the user close the browser after a succesfull payment but before
                being redirect to the shop page then the virtuemart system will still be updated. The Server to Server method is recomended.</td>
          </tr>

          <tr>
	          <td><strong>IPSPAY Shared Key</strong></td>
              <td><input type="text" name="IPSPAY_SHARED_KEY" class="inputbox" value="<?php  echo IPSPAY_SHARED_KEY ?>" /></td>
              <td>The IPS certificate stored in the IPS system. This is required when Order Encode Type is set to MD5 and must have the
                same value like the one stored in the IPS system.</td>
          </tr>
          
          <tr>
	          <td><strong>IPSPAY Return Type</strong></td>
              <td>
			  		<select name="IPSPAY_RETURN_TYPE">
			  		<?php 
					$currencys = array( '0'=>'Browser Return',
					    '1' => 'Server to Server');
					
					foreach($currencys as $k => $v)
					{
						if(IPSPAY_RETURN_TYPE == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>
					</select>
              <td>The Server to Server method include a call back to the notify script. So in case the user close the browser after a succesfull payment but before
                being redirect to the shop page then the virtuemart system will still be updated. The Server to Server method is recomended.</td>
          </tr>
          
          <tr>
	          <td><strong>IPSPAY Return Encode Type</strong></td>
              <td>
			  		<select name="IPSPAY_RETURN_ENCODE_TYPE">
			  		<?php 
					$currencys = array('10' => 'Old Style',
					    '11'=>'Md5 With Rsa',
					    '12' => 'Md5');
					
					foreach($currencys as $k => $v)
					{
						if(IPSPAY_RETURN_ENCODE_TYPE == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>
					</select>
              <td>The Server to Server method include a call back to the notify script. So in case the user close the browser after a succesfull payment but before
                being redirect to the shop page then the virtuemart system will still be updated. The Server to Server method is recomended.</td>
          </tr>


          <tr>
	          <td><strong>IPSPAY Payment Page Language</strong></td>
              <td>
			  		<select name="IPSPAY_LANGUAGE">
			  		<?php 
					$languages = array('GB'=>'GB Chinese',
					    'EN'=>'English',
						'BIG5'=>'BIG5 Chinese',
						'JP'=>'Japanese',
						'FR'=>'Frensh');
						
					foreach($languages as $k=>$v) 
					{
						if(IPSPAY_LANGUAGE == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>
					</select>
              <td>The language you wish the payment page to be displayed in.</td>
          </tr> 
          <tr>
	          <td><strong>IPSPAY Transaction Curreny</strong></td>
              <td>
			  		<select name="IPSPAY_CURRENCY">
			  		<?php 
					$currencys = array( 'RMB'=>'RMB');
					
					foreach($currencys as $k => $v)
					{
						if(IPSPAY_CURRENCY == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>
					</select>
              <td>The currency which the transaction will be placed through IPSPAY.</td>
          </tr>
          
          <tr>
	          <td><strong>IPSPAY Gateway type</strong></td>
              <td>
			  		<select name="IPSPAY_GATEWAY_TYPE">
					<?php 

					$debug_status = array('01' => 'RMB debit cards', 
					    '02' => 'International credit cards',
					    '03' => 'IPS Account',
					    '04' => 'EPOS');

					foreach($debug_status as $k => $v) 
					{
						if(IPSPAY_GATEWAY_TYPE == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>				
					</select>
              <td>Type of account using for payments trough the IPS.</td>
          </tr>

          <tr>
	          <td><strong>IPSPAY Development Mode</strong></td>
              <td>
			  		<select name="IPSPAY_DEV">
					<?php 
					$debug_status = array('0'=>'No', '1'=>'Yes');
					foreach($debug_status as $k => $v) 
					{
						if(IPSPAY_DEV == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>				
					</select>
              <td>Set to yes to activate development mode on the payment module. 
                The payments will be send to the IPSPAY_DEV_URL which is genereting fake payments for testing purposes.</td>
          </tr> 
          <tr>
	          <td><strong>IPSPAY Debug Mode</strong></td>
              <td>
			  		<select name="IPSPAY_DEBUG">
					<?php 
					$debug_status = array('0'=>'No', '1'=>'Yes');
					foreach($debug_status as $k => $v) 
					{
						if(IPSPAY_DEBUG == $k)
						{
							echo '<option value="' . $k . '" selected="selected">' . $v . '</option>'."\n";
						}
						else
						{
							echo '<option value="' . $k . '">' . $v . '</option>'."\n";
						}
					}
					?>				
					</select>
              <td>Set to yes to activate debug mode on the payment module.  The raw IPSPAY processing data will be 
			  displayed on the payment result page if set to yes.</td>
          </tr>

  		  <tr>
              <td><strong>Order Status for successful transactions</strong></td>
              <td>
                	<select name="IPSPAY_VERIFIED_STATUS" class="inputbox" >
                	<?php
						$q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
						$db->query($q);
						$order_status_code = Array();
						$order_status_name = Array();
						
						while($db->next_record())
						{
						    $order_status_code[] = $db->f("order_status_code");
						    $order_status_name[] =  $db->f("order_status_name");
						}
						
						for($i = 0; $i < sizeof($order_status_code); $i++)
						{
						    echo "<option value=\"" . $order_status_code[$i];
						    if (IPSPAY_VERIFIED_STATUS == $order_status_code[$i])
						    {
						        echo "\" selected=\"selected\">";
						    }
						    else
						    {
							    echo "\">";
							}
							
						  echo $order_status_name[$i] . "</option>\n";
						}
				    ?>
                    </select>
              </td>
              <td>Select the order status to which the actual order is set, if the IPSPAY processing is successful. 
			  	If using download selling options: select the status which enables the download (then the customer is instantly notified about the download via e-mail).</td>
            </tr>
            <tr>
              <td><strong>Order Status for Pending Payments</strong></td>
              <td>
                	<select name="IPSPAY_PENDING_STATUS" class="inputbox" >
	                <?php
						for($i = 0; $i < sizeof($order_status_code); $i++)
						{
						    echo "<option value=\"" . $order_status_code[$i];
						    
						    if (IPSPAY_PENDING_STATUS == $order_status_code[$i])
						    {
						        echo "\" selected=\"selected\">";
    					    }
    					    else
    					    {
    					        echo "\">";
							}
							
							echo $order_status_name[$i] . "</option>\n";
						} 
					?>
					</select>
            </td>
            <td>The order Status to which Orders are set, which have no completed Payment Transaction. 
            The transaction was not cancelled in this case, but it is just pending and waiting for completion.</td>
          </tr>
          <tr>
              <td><strong>Order Status for failed transactions</strong></td>
              <td>
                	<select name="IPSPAY_INVALID_STATUS" class="inputbox" >
                	<?php
						for($i = 0; $i < sizeof($order_status_code); $i++)
						{
						    echo "<option value=\"" . $order_status_code[$i];
						    if (IPSPAY_INVALID_STATUS == $order_status_code[$i]) 
						    {
						        echo "\" selected=\"selected\">";
						    }
						    else
						    {
						        echo "\">";
						    }
						    echo $order_status_name[$i] . "</option>\n";
						}
					?>
                    </select>
              </td>
              <td>Select an order status for failed IPSPAY transactions.</td>
          </tr>
          <tr>
	          <td><strong>Notification Message on Verified Status</strong></td>
              <td><textarea cols="30" rows="5" name="IPSPAY_VERIFIED_STATUS_MESSAGE" class="inputbox"><?php  echo IPSPAY_VERIFIED_STATUS_MESSAGE ?></textarea></td>
              <td>The short message that will be included in the notification email when an order if changed to verified status after an accepted IPS processing.</td>
          </tr> 		  
          <tr>
	          <td><strong>Notification Message on Invalid Status</strong></td>
              <td><textarea cols="30" rows="5" name="IPSPAY_INVALID_STATUS_MESSAGE" class="inputbox"><?php  echo IPSPAY_INVALID_STATUS_MESSAGE ?></textarea></td>
              <td>The short message that will be included in the notification email when an order if changed to invalie status after a declined IPS processing .</td>
          </tr> 		  
        </table>
        <?php
        
        return true;
    }
    
    function has_configuration() {
      // return false if there's no configuration
      return true;
   }
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
    /**
    * Returns the "is_readable" status of the configuration file
    * @param void
    * @returns boolean True when the configuration file is writeable, false when not
    */
    function configfile_readable()
    {
        return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
    }
   
    /**
    * Writes the configuration file for this payment method
    * @param array An array of objects
    * @returns boolean True when writing was successful
    */
    function write_configuration(&$d)
    {
        $my_config_array = array( "IPSPAY_DEV_URL"=>$d['IPSPAY_DEV_URL'],
            "IPSPAY_LIVE_URL"                   => $d['IPSPAY_LIVE_URL'],
            "IPSPAY_DEBUG"                      => $d['IPSPAY_DEBUG'],
            "IPSPAY_DEV"                        => $d['IPSPAY_DEV'],
            "IPSPAY_MERCHANT_CODE"              => $d['IPSPAY_MERCHANT_CODE'],
            "IPSPAY_LANGUAGE"                   => $d['IPSPAY_LANGUAGE'],
            "IPSPAY_CURRENCY"                   => $d['IPSPAY_CURRENCY'],
            "IPSPAY_GATEWAY_TYPE"               => $d['IPSPAY_GATEWAY_TYPE'],
            "IPSPAY_RETURN_TYPE"                => $d['IPSPAY_RETURN_TYPE'],
            "IPSPAY_ORDER_ENCODE_TYPE"          => $d['IPSPAY_ORDER_ENCODE_TYPE'],
            "IPSPAY_RETURN_ENCODE_TYPE"         => $d['IPSPAY_RETURN_ENCODE_TYPE'],
            "IPSPAY_SHARED_KEY"                 => $d['IPSPAY_SHARED_KEY'],
            "IPSPAY_VERIFIED_STATUS"            => $d['IPSPAY_VERIFIED_STATUS'],
            "IPSPAY_PENDING_STATUS"             => $d['IPSPAY_PENDING_STATUS'],
            "IPSPAY_INVALID_STATUS"             => $d['IPSPAY_INVALID_STATUS'],
            "IPSPAY_VERIFIED_STATUS_MESSAGE"    => $d['IPSPAY_VERIFIED_STATUS_MESSAGE'],
            "IPSPAY_INVALID_STATUS_MESSAGE"     => $d['IPSPAY_INVALID_STATUS_MESSAGE']);
									    
        $config = "<?php\n";
        $config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );";
        foreach($my_config_array as $key => $value)
        {
            $config .= "define ('$key', '$value');\n";
        }

        $config .= "?>";
  
        if($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w"))
        {
            fputs($fp, $config, strlen($config));
            fclose ($fp);
            return true;
        }
        else
        {
            return false;
        }
   }
   
    /**************************************************************************
    ** name: process_payment()
    ** returns: 
    ***************************************************************************/
    function process_payment($order_number, $order_total, &$d)
    {
        return true;
    }
   
}
