<?php 
/**
* IPSPAY Order Confirmation Handler
* Used in conjunction with the IPSpay payment module
* for transactions with ipspay.com, a Credit card processor using their Hosted page solution. 
*
* @version $Id: ps_ipspay_notify.php,v 1.0 2010/05/01 
* @package VirtueMart
* @subpackage payment
*
* IPSPay B.V. Netherlands. (http://www.ipspay.com/)
* VirtueMart (http://virtuemart.net)
*/

// IPSPAY posts info back.
// TESTING
/*

$handle = fopen("/home/noblechic/domains/noblechic.com/public_html/administrator/components/com_virtuemart/" . "log.txt", "a");
fputs($handle, "Requ\n", 5);
foreach($_POST as $k => $v)
{
    fputs($handle, "\nPOST ", 6);
    fputs($handle, $k, strlen($k));
    fputs($handle, " Val \n", 6);
    fputs($handle, $v, strlen($v));
}
foreach($_GET as $k => $v)
{
    fputs($handle, "\nGET ", 5);
    fputs($handle, $k, strlen($k));
    fputs($handle, " Val \n", 6);
    fputs($handle, $v, strlen($v));
}
*/

// comment this line if you want to debug the scritp. 
// some warnings are creating problems
error_reporting(0);

// must be notification from ipspay
if(isset($_GET)) 
{
	//header("Status: 200 OK");
    global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database, $mosConfig_mailfrom, $mosConfig_fromname;

    /*** access Joomla's configuration file ***/
    $my_path = dirname(__FILE__);

    if( file_exists($my_path."/../../../configuration.php"))
    {
        $absolute_path = dirname( $my_path."/../../../configuration.php" );
        require_once($my_path."/../../../configuration.php");
    }
    elseif( file_exists($my_path."/../../configuration.php"))
    {
        $absolute_path = dirname( $my_path."/../../configuration.php" );
        require_once($my_path."/../../configuration.php");
    }
    elseif( file_exists($my_path."/configuration.php"))
    {
        $absolute_path = dirname( $my_path."/configuration.php" );
        require_once( $my_path."/configuration.php" );
    }
    else {
        die( "Joomla Configuration File not found!" );
    }

    $absolute_path = realpath( $absolute_path );

    // Set up the appropriate CMS framework
    if( class_exists( 'jconfig' ) ) {
		define( '_JEXEC', 1 );
		define( 'JPATH_BASE', $absolute_path );
		define( 'DS', DIRECTORY_SEPARATOR );
		
		// Load the framework
		require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
		require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

		// create the mainframe object
		$mainframe = & JFactory::getApplication( 'site' );
		
		// Initialize the framework
		$mainframe->initialise();
		
		// load system plugin group
		JPluginHelper::importPlugin( 'system' );
		
		// trigger the onBeforeStart events
		$mainframe->triggerEvent( 'onBeforeStart' );
		$lang =& JFactory::getLanguage();
		$mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
		// Adjust the live site path
		$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
		$mosConfig_absolute_path = JPATH_BASE;
    } else {
    	define('_VALID_MOS', '1');
    	require_once($mosConfig_absolute_path. '/includes/joomla.php');
    	require_once($mosConfig_absolute_path. '/includes/database.php');
    	$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
    	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
    
        // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' ))
        {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        }
        else if(file_exists($mosConfig_absolute_path. '/language/english.php'))
        {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
        else
        {
            die( "Joomla Language File not found!" );
        }
    }
	/*** END Joomla part ***/
	
	/*** VirtueMart part ***/        
    //require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
    require_once('virtuemart.cfg.php');

    include_once( ADMINPATH.'/compat.joomla1.5.php' );
    global $VM_LANG;
    
    $mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', $mosConfig_live_site);
    require_once( ADMINPATH. 'global.php' );
    require_once( CLASSPATH. 'ps_main.php' );
    require_once( CLASSPATH . "language.class.php" );
    
    /* Load the IPSPAY Configuration File */ 
    require_once( CLASSPATH. 'payment/ps_ipspay.cfg.php' );
    
    /* Load the VirtueMart database class */
    require_once( CLASSPATH. 'ps_database.php' );

	require_once(CLASSPATH."Log/Log.php");
	$vmLoggerConf = array(
		'buffering' => true
		);
	/**
	 * This Log Object will help us log messages and errors
	 * See http://pear.php.net/package/Log
	 * @global Log vmLogger
	 */
	$GLOBALS['vmLogger'] = $vmLogger = &vmLog::singleton('display', '', '', $vmLoggerConf, PEAR_LOG_TIP);
	
	// Constructor initializes the session!
    require_once( CLASSPATH. 'ps_session.php' );
	$sess = new ps_session();
    			
    /*** END VirtueMart part ***/
    if(IPSPAY_DEBUG == '1')
	{
	    // echo out the return values
		echo '<h3>DEBUG MODE ON</h3>';
		echo '<p>The following shows the GET fields that have been returned from IPSPAY. Turn debug off to hide debug code.</p>';
        foreach($_GET as $k => $v)
        {
            echo $k . ': ' . $v . '<br/>';
        }
    }

    $trans_status = '0';
    if(isset($_SESSION['order_id']))
    {
        $order_id = $_SESSION['order_id'];
    }
    
	if((isset($_GET['server_success']) && $_GET['server_success'] == '1') ||
    	(isset($_GET['success']) && $_GET['success'] == '1') ||
    	(isset($_GET['fail']) && $_GET['fail'] == '1'))
	{
		/*** IPSPAY Response Processing from ipspay not user feedback ***/ 

		// process response.
		
        $order_id = trim(stripslashes($_GET['billno']));
        $mercode = trim(stripslashes($_GET['mer_code']));
        $amount = trim(stripslashes($_GET['amount']));
        $order_date = trim(stripslashes($_GET['date']));
        $succ = trim(stripslashes($_GET['succ']));
        $msg = trim(stripslashes($_GET['msg']));
        
        $ipsbillno = '';
        if(isset($_GET['ipsbillno']))
        {
            $ipsbillno = trim(stripslashes($_GET['ipsbillno']));
        }
        
        $retencodetype = 10;
        if(isset($_GET['retencodetype']))
        {
            $retencodetype = trim(stripslashes($_GET['retencodetype']));
        }
        
        $attach = trim(stripslashes($_GET['attach']));
        $currency_type = trim(stripslashes($_GET['Currency_type']));
        $signature = trim(stripslashes($_GET['signature']));
        
        $ipsbanktime = '';
        if(isset($_GET['ipsbanktime']))
        {
            $ipsbanktime = trim(stripslashes($_GET['ipsbanktime']));
        }
        
        $bankbillno = '';
        if(isset($_GET['bankbillno']))
        {
            $bankbillno = trim(stripslashes($_GET['bankbillno']));
        }
		
		// verify if there is an order in the system to match the order that has been paid.
		// Get the Order Details from the database
		$qv = "SELECT * FROM #__{vm}_orders ";
		$qv .= "WHERE order_id='" . $order_id . "'";
		$dbbt = new ps_DB;
		$dbbt->query($qv);
		$dbbt->next_record();
		$d['order_number'] = $dbbt->f("order_number");
		$d['order_id'] = $dbbt->f("order_id");

        //$signature = md5($product_id . "-" . substr($dbbt->f("order_total"), 0, -3) . IPSPAY_SHARED_KEY);
        $trans_status = '0';
        $valid_response = false;
        $error_message = array();
        
        //type of return encoding should match our internal settings. If there is no match
        // them there are some problems so we stop the processing of the order
        if($retencodetype == IPSPAY_RETURN_ENCODE_TYPE)
        {
            $calc_sign = '';
            switch($retencodetype)
            {
                case 10:
                    $calc_sign = $order_id . substr($dbbt->f("order_total"), 0, -3) . $order_date . $succ . $currency_type;
                    break;
                case 11:
                    $calc_sign = $order_id . substr($dbbt->f("order_total"), 0, -3) . $order_date . $succ . $ipsbillno . $currency_type;
                    $calc_sign = md5($calc_sign);
                    break;
                case 12:
                    $calc_sign = $order_id . substr($dbbt->f("order_total"), 0, -3) . 
                        $order_date . $succ . $ipsbillno . $currency_type . IPSPAY_SHARED_KEY;
                    $calc_sign = md5($calc_sign);
                    break;
                default:
                    $error_message[] = 'Return order encoding type NOT DEFINED.'; 
            }

            if($calc_sign == $signature)
            {
    		    if($dbbt->f("order_status") == IPSPAY_VERIFIED_STATUS)
                {
                    // probably the other method arrived earlyer.
                    // so we set the transaction status to 1 but we set the 
                    // valid response to 0 (it is a valid response but we already processed
                    // this response)
                    $trans_status = '1';
                    $valid_response = false;
                }
                else
                {
                    $valid_response = true;
                }
            }
            else
            {
                $error_message[] = 'Signature are not matching.'; 
                $trans_status = '0';
                $valid_response = false;
            }
        }
        else
        {
            $error_message[] = 'Return order encoding type is not matching our internal settings.'; 
            $trans_status = '0';
            $valid_response = false;
        }
    	
    }
    
    if(IPSPAY_DEBUG == '1')
    {
        echo "Error Array: <br />";
        print_r($error_message);
    }
        
	// right... if valid response.. update order depending on response
	if($valid_response)
	{
	    $trans_name = 'IPS Transaction';
	    
		$db = new ps_DB;
		
		if($succ == 'Y')
		{
			// succesful transaction
            $trans_log = 'IPSpay Successful Transaction' . "<br/>" .
                    'IPS Bill No: ' . $ipsbillno . "<br/>" .
                    'IPS Msg: ' . $msg . "<br/>" .
                    'IPS Bank Time: ' . $ipsbanktime . "<br/>" .
                    'IPS Bank Bill No: ' . $bankbillno  . "<br/>";

			// update the order details with the transaction id/name/etc..
			$q = "UPDATE #__{vm}_order_payment SET";
			$q .= " order_payment_name ='$trans_name', ";
			$q .= " order_payment_log ='$trans_log', ";
			$q .= " order_payment_trans_id ='$trans_id' ";
		    $q .= "WHERE order_id ='$order_id'";

			$db->query($q);
			$db->next_record();
		
			// update the order status and send out notification email
			$d['order_status'] = IPSPAY_VERIFIED_STATUS;
			$d['notify_customer'] = 'Y';
			$d['include_comment'] = "Y";
			$d['order_comment'] = IPSPAY_VERIFIED_STATUS_MESSAGE;

			require_once ( CLASSPATH . 'ps_main.php' );
			require_once ( CLASSPATH . 'ps_order.php' );
			$ps_order= new ps_order;
			$ps_order->order_status_update($d);

			$trans_status = '1';
		}
		else
		{
			// transaction delined
			$trans_log = 'IPSpay Declined Transaction' . "<br/>" .
                    'IPS Bill No: ' . $ipsbillno . "<br/>" .
                    'IPS Msg: ' . $msg . "<br/>" .
                    'IPS Bank Time: ' . $ipsbanktime . "<br/>" .
                    'IPS Bank Bill No: ' . $bankbillno  . "<br/>";

			// update the order details with the transaction id/name/etc..
			$q = "UPDATE #__{vm}_order_payment SET";
			$q .= " order_payment_name ='$trans_name', ";
			$q .= " order_payment_log ='$trans_log', ";
			$q .= " order_payment_trans_id ='$trans_id' ";
			$q .= "WHERE order_id ='$order_id'";
			$db->query($q);
			$db->next_record();

			// update the order status and send notification email
			$d['order_status'] = IPSPAY_INVALID_STATUS;
			$d['notify_customer'] = 'Y';
			$d['include_comment'] = "Y";			
			$d['order_comment'] = IPSPAY_INVALID_STATUS_MESSAGE;
			
			require_once ( CLASSPATH . 'ps_main.php' );
			require_once ( CLASSPATH . 'ps_order.php' );
			$ps_order= new ps_order;
			$ps_order->order_status_update($d);

			$trans_status = '0';
		}
	}

    if(IPSPAY_DEBUG != '1' &&
        !isset($_GET['server_success']))
	{
	    $result_string = base64_encode($trans_status . ':' . $order_id);
        $results_url = $mosConfig_live_site . '/index.php?option=com_virtuemart&page=checkout.ipspay_result&result=' . $result_string;
	    header('Location: ' .$results_url);
	}
	
}	// end notification


?>
